![](https://media.licdn.com/dms/image/C4D12AQG6uImV4n37jg/article-inline_image-shrink_1000_1488/0?e=1560384000&v=beta&t=YaOaA1VZ0RZelhM9k4TiJtzfevgcnqAhiIWy0zLPDUc)



Graphic taken from Data Science Central



The picture is accurate, but the more relevant question is “When would each technique be at an advantage?”  



The obvious difference, correctly depicted, is that the Deep Neural Network is estimating many more parameters and even more permutations of parameters than the logistic regression. Therefore the real question is in what situations would that be a good idea? 



You need a good ratio of data points to parameters to get reliable estimates so the first criteria would be lots of data in order to estimate lots of parameters. If that's not true then you'd be estimating lots of parameters with little data per parameter and get a bunch of spurious results. Therefore depending upon the situation, the additional granularity of the Deep Neural Network would either represent a treasure trove of additional detail and value, or an error prone and misleading representation of the situation. 



The second key difference is the need to understand “why the prediction works” or the need to restrict the equation from using certain data in specific ways. We've all heard the example of drownings and ice cream sales being correlated together because more people both swim and drown in the summer time and also eat more ice cream in the summer. Ice cream sales might help indicate “when people will drown”, but it’s not going to indicate “why people are drowning”. The need to know “why” means that it’s important to restrict the ways data is used and assure logical inference. The more convoluted the formula and the less involved the analyst is the less you’ll be able to understand what caused what or why a prediction works and when it might stop working. Understanding the why is better suited to more parsimonious techniques with careful involvement of the analyst.



On the other hand sometimes the “why” is not as important as simply “what is”. A ground breaking application of Deep Neural Networks is in the area of machine vision or the correct classification of pictures or the translation of video into analyzable data. Pictures and video have enormous amounts of information and detail. So much so that it’s very difficult to effectively use it all without heavy automation. That’s the perfect fit for a Deep Learning Neural Network.



Both techniques, as well as their many cousins, have tremendous opportunities to add value if applied to the problems they’re best suited for and conversely, as with any technique, they could also lead to problems if naively applied inappropriately.



If you liked this discussion, I’d appreciate you sharing it or clicking the “like” button. Your vote of approval helps spread the publicity and is always appreciated and useful in the prioritization of further content.



**David Young has worked in Marketing Analytics 20+ years and lives in Vienna, VA**



If you enjoyed this you might enjoy my book:



Book preview and always in stock at the Publisher: [https://store.bookbaby.com//bookshop/book/index.aspx?bookURL=A-Short-Guide-to-Marketing-Model-Alignment-and-Design](https://store.bookbaby.com/bookshop/book/index.aspx?bookURL=A-Short-Guide-to-Marketing-Model-Alignment-and-Design)



Also at Amazon: [https://www.amazon.com/Short-Guide-Marketing-Alignment-Design/dp/1543912591/ref=sr_1_1?ie=UTF8&qid=1510196791&sr=8-1&keywords=a+short+guide+to+marketing+model+alignment+%26+design](https://www.amazon.com/Short-Guide-Marketing-Alignment-Design/dp/1543912591/ref=sr_1_1?ie=UTF8&qid=1510196791&sr=8-1&keywords=a+short+guide+to+marketing+model+alignment+&+design)

